<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { ref, inject } from 'vue';
import { storeToRefs } from 'pinia';
import { useI18n } from 'vue-i18n';
import Modal from '@/components/general/Modal.vue';
import { useMetaStore } from '@/stores/meta';
import { adminMenuEnum, paneTypes } from '@/enums/enums';
import Checkbox from '@/components/general/form/Checkbox.vue';
import Button from '@/components/general/Button.vue';

const { t } = useI18n();
const $t = t; 

const emits = defineEmits<{
    (e: 'close', value: boolean): void
}>();

let configuration = inject<any>('configuration');

const store = useMetaStore();
const { paneType, noPassHash, getCommentsAllowed, openMenu } = storeToRefs(store);

const size = ref('A4');
const layout = ref('portrait');
const comments = ref(getCommentsAllowed.value);

const pageSizes = configuration!.export.pageSizes;
const pageLayouts = configuration!.export.pageLayouts;

const submit = ()=>{
    let url = configuration!.basePath + `dl?panetype=${(paneType.value === paneTypes.SCHEDULE || paneType.value === paneTypes.STREAM?"s":"f")}&paneid=${noPassHash.value}&type=pdf&size=${size.value}&layout=${layout.value}&comments=${comments.value}`;
    window.open(url, '_blank');
    cancel();
}

const cancel = ()=>{
    size.value = "A4";
    layout.value = "portrait";
    comments.value = getCommentsAllowed.value;
    //emits('close', false);
    openMenu.value = adminMenuEnum.NONE;
}

const setSize = (value:string)=>{
    size.value = value;
}

const setLayout = (value:string)=>{
    layout.value = value;
}

</script>
<template>
<Modal :header="$t('exportPage.pdf.label')" :labelSubmit="$t('exportPage.pdf.submit')" @submit="submit" :labelCancel="$t('general.buttons.cancel')" @cancel="cancel">
    <form class="flex flex-col gap-3 mt-2" @submit.prevent>
        <div class="flex flex-col gap-1">
            <label class="text-gray-700">{{$t("exportPage.pdf.size.label")}}</label>
            <div class="flex flex-row">
                <div class="w-12" :key="'size_'+index" v-for="e,index in pageSizes" @click="setSize(e)">
                    <Button size="small" :variant="e===size?'confirm':'white'">
                        {{e}}
                    </Button>
                </div>
            </div>
        </div>
        <div class="flex flex-col gap-1">
            <label class="text-gray-700">{{$t("exportPage.pdf.layout.label")}}</label>
            <div class="flex flex-row">
                <div class="w-fit" :key="index" v-for="e,index in pageLayouts" @click="setLayout(e)">
                    <Button size="small" :variant="e===layout?'confirm':'white'">
                        {{$t(`exportPage.pdf.layout.${e}`)}}
                    </Button>
                </div>
            </div>
        </div>
        <div>
            <Checkbox v-model="comments" :label="$t('general.variables.comment.pl')" v-if="getCommentsAllowed"/>
        </div>
    </form>
</Modal>
</template>